#include <stdio.h>
#include <wchar.h>

#include "print_helper.h"
#include "global_vars.h"

void pr_warning(const char* format, ...) {
    va_list args;

    va_start(args, format);
    fprintf(stdout, format, args);
    va_end(args);
    fflush(stdout);
}

void pr_error(const char *format, ...) {
    va_list args;

    va_start(args, format);
    fprintf(stderr, format, args);
    va_end(args);
    fflush(stderr);
}

#if DEBUG
void pr_debug(const char *format, ...) {
    va_list args;

    va_start(args, format);
    fprintf(stderr, format, args);
    va_end(args);
    fflush(stderr);
}
#else
void pr_debug(const char *format, ...);
#endif /* DEBUG */

void wpr_warning(const wchar_t *format, ...) {
    va_list args;

    va_start(args, format);
    fwprintf(stdout, format, args);
    va_end(args);
    fflush(stdout);
}

void wpr_error(const wchar_t *format, ...) {
    va_list args;

    va_start(args, format);
    fwprintf(stderr, format, args);
    va_end(args);
    fflush(stderr);
}

void wprint_token(FILE* out_file) {
    if (tokenType == MOT || tokenType == MOTCLE) {
        fwprintf(out_file, L"%20s: %ls\n", tokenTypestr[tokenType], token[tokenFound].value);
    } else {
        fwprintf(out_file, L"%20s\n", tokenTypestr[tokenType]);
    }
    fflush(out_file);
}
